

#include <stdio.h>

#include <avr/io.h>

#include "uart.h"

#include "i2cmaster.h"

#include <stdlib.h>



//UART Initialisierung

#define BAUD 19200
#define FOSC 4000000
#define MYUBRR FOSC/16/BAUD-1 // Equation for Calculating, UBRRn Value, asynchronus normal mode

#define L_Device_ADDRESS                   0x45        //69      
#define L_Sensor_ADDRESS_Command           0x00        //set
#define L_Sensor_ADDRESS_Command_Function  0x82        //set
#define L_Sensor_ADDRESS_Control           0x01        //set 
#define L_Sensor_ADDRESS_Control_Function  0x0C        //set
#define L_Sensor_ADDRESS_LSB_BYTE          0x04        //read
#define L_Sensor_ADDRESS_MSB_BYTE          0x05        //read


void USART_Init(unsigned int); 
void USART_Transmit( unsigned int);
unsigned char USART_Receive( void );
void USART_Transmit_String(char *str);

unsigned char i2c_start(unsigned char); 
void i2c_stop(void); 
unsigned char i2c_write(unsigned char); 



//#define Dev24C02  0xA2      // device address of EEPROM 24C02, see datasheet


 int main(void)
 {

USART_Init(MYUBRR);

 while (1) {

if(!(i2c_start(L_Device_ADDRESS +I2C_WRITE))) //Slave bereit zum schreiben?
{
  

     unsigned char ret;
	 unsigned char Buffer[20];
	 

     i2c_start_wait(L_Device_ADDRESS+I2C_WRITE); 
     i2c_write(L_Sensor_ADDRESS_Command);                        // write address = 5
     i2c_write(L_Sensor_ADDRESS_Command_Function);               // write value 0x75 to EEPROM
	 USART_Transmit('A');
     i2c_stop();                             // set stop conditon = release bus

     i2c_start_wait(L_Device_ADDRESS+I2C_WRITE);     // set device address and write mode
     i2c_write(L_Sensor_ADDRESS_Control);                        // write address = 5
     i2c_write(L_Sensor_ADDRESS_Control_Function);
	 USART_Transmit('B');
	 
	                         
     i2c_stop();   


     // read previously written value back from EEPROM address 5 
     i2c_start_wait(L_Device_ADDRESS+I2C_WRITE);     // set device address and write mode
     i2c_write(L_Sensor_ADDRESS_LSB_BYTE);                        // write address = 5
     i2c_stop();
     i2c_start_wait(L_Device_ADDRESS+I2C_READ);       // set device address and read mode
     USART_Transmit('C');
     ret = i2c_readAck();
     itoa(ret,Buffer,10);


     USART_Transmit(Buffer);
     i2c_stop();

     //for(;;);
 
 }
else
{
  i2c_stop();/* Hier knnte eine Fehlermeldung ausgegeben werden... */
}
 
 }
}



